## darktable 0.9.3

=== CMakeLists.txt ===
project(darktable CXX C)
cmake_minimum_required(VERSION 2.6)
cmake_policy(VERSION 2.6)

option(USE_GCONF_BACKEND "Detect and use gconf backend if available." ON)
option(USE_CAMERA_SUPPORT "Detect and use camera support if available." ON)
option(USE_NLS "Build Native Language Support (using gettext)" ON)
option(USE_FLICKR "Enable Flickr support" ON)
option(USE_KWALLET "Build kwallet password storage backend" ON)
option(USE_GNOME_KEYRING "Build gnome-keyring password storage backend" ON)
option(BUILD_SLIDESHOW "Build the opengl slideshow viewer" ON)
option(USE_OPENMP "Use openmp threading support." ON)
option(USE_OPENCL "Use OpenCL support." ON)
option(USE_DARKTABLE_PROFILING OFF)
option(DONT_USE_RAWSPEED "Dont compile rawspeed backend." OFF)
option(DONT_INSTALL_GCONF_SCHEMAS "Dont install gconf schemas, usefull for package creation." OFF)
option(BUILD_USERMANUAL "Build all the versions of the usermanual." OFF)
option(INSTALL_IOP_EXPERIMENTAL "Also install unstable, unfinished, broken, and likely-to-change-soon plugins." OFF)
option(INSTALL_IOP_LEGACY "Also install old plugins we want to get rid of." OFF)
option(BINARY_PACKAGE_BUILD "Sets march optimization to generic" OFF)
option(APRIL_FOOLS "Add the \"file manager\" (a shell) to lighttable mode" OFF)

# Generate multi arch triplet
EXECUTE_PROCESS(COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH OUTPUT_VARIABLE CMAKE_ARCH_TRIPLET OUTPUT_STRIP_TRAILING_WHITESPACE)
if(CMAKE_ARCH_TRIPLET)
	message("-- mutliarch triplet detected: " ${CMAKE_ARCH_TRIPLET})
	LIST(INSERT CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES 0 /lib/${CMAKE_ARCH_TRIPLET}
		/usr/lib/${CMAKE_ARCH_TRIPLET})
endif()

#
# Set platform defaults...
#
if(APPLE)
	message("-- Mac OSX build detected, setting default features")
	set(USE_GCONF_BACKEND OFF) 
	set(USE_OPENCL OFF)
	set(USE_CAMERA_SUPPORT OFF)
	set(BUILD_SLIDESHOW OFF)

	# setup mac ports path...
	set(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /opt/local/lib)
	set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} /opt/local/include)
	
	set(LIBS ${LIBS} -Wl,-framework -Wl,Carbon)

	if(USE_OPENCL)
	  set(LIBS ${LIBS} -Wl,-framework -Wl,OpenCL)
	endif(USE_OPENCL)
endif(APPLE)

if(WIN32)
 message("-- Win32 build detected, setting default features")
  set(USE_GCONF_BACKEND OFF) 
  set(USE_CAMERA_SUPPORT OFF)
endif(WIN32)

# Check if this is source package build
if(NOT IS_DIRECTORY ${CMAKE_SOURCE_DIR}/.git)
	set(SOURCE_PACKAGE 1)
endif()

#
# Set package version
#
if(NOT SOURCE_PACKAGE)
	message("-- Determining version")
	exec_program(git ${CMAKE_CURRENT_SOURCE_DIR} ARGS describe --tags HEAD | "sed 's,^release-,,;s,-,+,;s,-,~,;'" OUTPUT_VARIABLE PROJECT_VERSION)
	configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/version.cmake.cmake" "${CMAKE_CURRENT_BINARY_DIR}/version.cmake" @ONLY)
else(NOT SOURCE_PACKAGE)
	include(cmake/version.cmake)
endif()

#
# Initial cmake/debian/postinst and prerm script for debian package
#
make_directory(${CMAKE_CURRENT_SOURCE_DIR}/packaging/debian)


#
# Avoid source tree pollution
#
If(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")

# Add a sensible build type default and warning because empty means no optimization and no debug info.
if(NOT CMAKE_BUILD_TYPE)
	message("WARNING: CMAKE_BUILD_TYPE is not defined!\n         Defaulting to CMAKE_BUILD_TYPE=RelWithDebInfo. Use ccmake to set a proper value.")
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(WIN32)
	set(SHARE_INSTALL "." CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
else(WIN32)
	if(NOT SHARE_INSTALL)
		set(SHARE_INSTALL "share/darktable" CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
	endif(NOT SHARE_INSTALL)
endif(WIN32)

mark_as_advanced(SHARE_INSTALL)

if(WIN32)
	set(LIB_INSTALL "." CACHE STRING "Library file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
else(WIN32)
	if(NOT LIB_INSTALL)
		set( LIB_INSTALL lib${LIB_SUFFIX} CACHE STRING "Library file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
	endif(NOT LIB_INSTALL)
endif(WIN32)

mark_as_advanced(LIB_INSTALL)

#need to put here do setting LOCALE_DIR variable
if(USE_NLS)
find_package(Gettext)
if(Gettext_FOUND)
	if(NOT LOCALE_DIR)
		if(WIN32)
			SET(LOCALE_DIR "bin/locale")
		elseif(APPLE)
			SET(LOCALE_DIR "share/locale")
		else()#other os
			SET(LOCALE_DIR "${CMAKE_INSTALL_PREFIX}/share/locale")
		endif(WIN32)
	endif(NOT LOCALE_DIR)
	
	if(NOT LOCALE_DIR)
		message(QUIET "Set LOCALE_DIR to path to get Gettext working")
	else()
		find_package(Msgfmt)
		if(Msgfmt_FOUND)
			message(STATUS "Found msgfmt to convert language file. Translation enabled")
			add_subdirectory(po)
		else()
			message(STATUS "Cannot find msgfmt to convert language file. Translation won't be enabled")
		endif()
	endif(NOT LOCALE_DIR)
endif(Gettext_FOUND)
endif(USE_NLS)

# needed to generate file "create_preferences.sh" accordingly
if(USE_OPENCL)
	SET(HAVE_OPENCL 1)
else()
	SET(HAVE_OPENCL 0)
endif(USE_OPENCL)

#
# Test SSE level
#
# if(NOT USE_SSE_FLAG)
# 	set(SSE_C_TESTS "sse4" "sse3" "sse2" "sse")
# 	message("-- Checking SSE instructions support by current CPU")
# 	foreach(sse_test ${SSE_C_TESTS})
# 		if(NOT SSE_FOUND)
# 			if(WIN32)
# 				set(SSE_CHECK_COMMAND "FAILURE")
# 			elseif(APPLE)
# 				set(SSE_CHECK_COMMAND sysctl -a | grep ${sse_test})
# 			else()#other os
# 				set(SSE_CHECK_COMMAND grep ${sse_test} /proc/cpuinfo)
# 			endif(WIN32)
# 			execute_process(COMMAND ${SSE_CHECK_COMMAND} RESULT_VARIABLE ret_var OUTPUT_VARIABLE out_var)
# 			
# 			if(ret_var EQUAL 0) # grep returns 0 on success
# 				set(SSE_FOUND TRUE)
# 				message("--  ${sse_test} detected and working.")
# 				set(USE_SSE_SET ${sse_test})
# 			endif(ret_var EQUAL 0)
# 			
# 		endif(NOT SSE_FOUND)
# 	endforeach(sse_test)
# endif(NOT USE_SSE_FLAG)
# 
# # set the SSE
# if(USE_SSE_SET)
# 	set(CMAKE_C_FLAGS ${CMAKE_C_FLAGS} "-m${USE_SSE_SET}")
# endif(USE_SSE_SET)

# Path to install gconf schemas into.
if(NOT DT_GCONF_SCHEMA_DIR)
  # a home install would use: "xml:readwrite:${HOME}/.gconf"
  # default gconftool-2 path (gconftool-2 --get-default-source), mostly "xml:merged:/etc/gconf/gconf.xml.defaults"
  execute_process (COMMAND gconftool-2 --get-default-source OUTPUT_VARIABLE DT_GCONF_SCHEMA_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
endif(NOT DT_GCONF_SCHEMA_DIR)

# setup some theme specific variables
set(THEME hicolor)
set(THEME_DIRECTORY ${CMAKE_INSTALL_PREFIX}/share/icons/${THEME})

# lets continue into build directories
add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(doc)

include(cmake/darktable-packaging.cmake)

# create_preferences.sh depending on opencl
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/tools/create_preferences.sh.in"
    "${CMAKE_CURRENT_BINARY_DIR}/create_preferences.sh"
    IMMEDIATE @ONLY)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== data/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

add_subdirectory(pixmaps)

add_subdirectory(kernels)

#
# install darktable faster wrapper
#
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/darktable-faster DESTINATION bin PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

#
# Generate and instal gtkrc
#
set(GTKRC_FONT_SIZE 8)
if(APPLE)
  # 8 is very tiny on mac
  set(GTKRC_FONT_SIZE 11)
endif(APPLE)
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/darktable.gtkrc.in ${CMAKE_CURRENT_BINARY_DIR}/darktable.gtkrc )


#
# Add files that should go into shared
#
set(SHARE_FILES ${CMAKE_CURRENT_BINARY_DIR}/darktable.gtkrc)
install(FILES ${SHARE_FILES} DESTINATION ${SHARE_INSTALL})

#
# web gallery export support files:
#
set(WEB_FILES style/style.css style/favicon.ico)
install(FILES ${WEB_FILES} DESTINATION ${SHARE_INSTALL}/style/)

#
# Install other system shares
#
install(FILES darktable.desktop DESTINATION ./share/applications)

#
# Install watermarks
#
FILE(GLOB WATERMARKS "watermarks/*.svg")
install(FILES ${WATERMARKS} DESTINATION ${SHARE_INSTALL}/watermarks)

#
# Install gdb command file for backtrace generation
#
install(FILES gdb_commands DESTINATION ${SHARE_INSTALL})

#
# Install gconf schema.
#

if(USE_GCONF_BACKEND)
  if(NOT DONT_INSTALL_GCONF_SCHEMAS)
    install (CODE "set(ENV{GCONF_CONFIG_SOURCE} ${DT_GCONF_SCHEMA_DIR})
        execute_process(WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} OUTPUT_QUIET COMMAND gconftool-2 --makefile-install-rule darktable.schemas)")
    install (CODE "message(\"-- Installing: gconf schemas to '${DT_GCONF_SCHEMA_DIR}'\")")
    install (CODE "execute_process(WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} OUTPUT_QUIET COMMAND killall -HUP gconfd-2)")
    install (CODE "message(\"-- Installing: restarting gconfd-2\")")
  else()
    install(FILES darktable.schemas DESTINATION /etc/gconf/schemas)
  endif(NOT DONT_INSTALL_GCONF_SCHEMAS)
else()
 # Setup some custom commands to generate a darktablerc template
 # out of the darktable.schemas file.
 add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys
    COMMAND 
        grep '<key>' ${CMAKE_CURRENT_SOURCE_DIR}/darktable.schemas | 
        sed -e 's/<key>//g' -e 's/<\\/key>//g' -e 's/\\/schemas\\/apps\\/darktable\\///g' | 
        nl -s: | 
        sed -e 's/^[ \\t]*//\;s/[ \\t]*$$//' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys
  )
 
  add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
    COMMAND 
        grep '<default>' ${CMAKE_CURRENT_SOURCE_DIR}/darktable.schemas | 
        sed -e 's/<default>//g' -e 's/<\\/default>//g' | 
        nl -s: | 
        sed -e 's/^[ \\t]*//\;s/[ \\t]*$$//' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
        
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys
  )
 
  add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc
    COMMAND 
      join -1 1 -2 1 -o 1.2 2.2 ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values | 
      sed -e 's/ /=/g' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc
      
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
  )
 
  add_custom_target(darktablerc ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc)
 
  # first of all install darktablerc file into share as template
  # postinst script should copy this into users homedirectory 
  # $HOME/.config/darktable/darktable.rc
  install(FILES darktablerc DESTINATION ${SHARE_INSTALL}/)
  
endif()

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

include(CheckCCompilerFlag)

#
# Add files for libdarktable
#
FILE(GLOB SOURCE_FILES
  "common/collection.c" 
  "common/colorlabels.c" 
  "common/colormatrices.c" 
  "common/colorspaces.c" 
  "common/darktable.c" 
  "common/exif.cc" 
  "common/film.c" 
  "common/fswatch.c" 
  "common/history.c" 
  "common/image.c" 
  "common/image_cache.c" 
  "common/image_compression.c" 
  "common/imageio.c" 
  "common/imageio_exr.cc" 
  "common/imageio_jpeg.c" 
  "common/imageio_module.c" 
  "common/imageio_pfm.c" 
  "common/imageio_rgbe.c" 
  "common/imageio_tiff.c" 
  "common/imageio_rawspeed.cc" 
  "common/metadata.c" 
  "common/styles.c" 
  "common/tags.c" 
  "common/utility.c" 
  "common/variables.c" 
  "common/pwstorage/pwstorage.c" 
  "common/pwstorage/backend_gconf.c"
  "common/opencl.c"
  "common/dynload.c"
  "common/dlopencl.c"
  "control/control.c"  
  "control/jobs/control_jobs.c"  
  "control/jobs/develop_jobs.c"  
  "control/jobs/film_jobs.c"
  "control/jobs/image_jobs.c"
  "develop/develop.c"
  "develop/imageop.c"
  "develop/pixelpipe.c"
  "develop/blend.c"
  "develop/tiling.c"
  "dtgtk/*.c"
  "gui/accelerators.c"
  "gui/background_jobs.c"
  "gui/contrast.c"  
  "gui/gtk.c"  
  "gui/histogram.c"  
  "gui/iop_history.c"  
  "gui/iop_modulegroups.c"  
  "gui/metadata.c"  
  "gui/navigation.c"  
  "gui/preferences.c"  
  "gui/presets.c"  
  "gui/styles_dialog.c"  
  "gui/tool_colorlabels.c"  
  "libs/lib.c"
  "views/view.c"
  )
FILE(GLOB HEADER_FILES "*.h" "common/*.h" "external/CL/*.h" "control/*.h" "iop/*.h" "libs/*.h", "views/*.h")

set(SOURCES ${SOURCE_FILES} ${HEADER_FILES})


include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/external)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/external/LibRaw)

# initial compiler flags
add_definitions("-DHAVE_CONFIG_H")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")

# Check for openmp
find_package(OpenMP)
if(OPENMP_FOUND AND USE_OPENMP)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  add_definitions("-DHAVE_OPENMP")
endif(OPENMP_FOUND AND USE_OPENMP)

if(USE_DARKTABLE_PROFILING)
	add_definitions(-DUSE_DARKTABLE_PROFILING)
	set(SOURCES ${SOURCES} "common/profiling.c")
endif()

#
# Find all other required libraries for building
#
find_package(GTK2 2.6 REQUIRED gtk)
include_directories(${GTK2_INCLUDE_DIRS})
list(APPEND LIBS ${GTK2_LIBRARIES})
add_definitions(${GTK2_DEFINITIONS})

# Check for libxml2 / broken cmake module can't be included in the foreach() below
find_package(LibXml2 2.6 REQUIRED)
include_directories(${LIBXML2_INCLUDE_DIR})
list(APPEND LIBS ${LIBXML2_LIBRARIES})
add_definitions(${LIBXML2_DEFINITIONS})


# Check for gconf2 / broken cmake module can't be included in the foreach() below
if(USE_GCONF_BACKEND)
  find_package(GConf2)
  include_directories(${GConf2_INCLUDE_DIRS})
  list(APPEND LIBS ${GConf2_LIBRARIES})
  add_definitions(${GConf2_DEFINITIONS})
endif(USE_GCONF_BACKEND)



if(USE_CAMERA_SUPPORT)
  find_package(Gphoto2)
  include_directories(${Gphoto2_INCLUDE_DIRS})
  list(APPEND LIBS ${Gphoto2_LIBRARIES})
  add_definitions(${Gphoto2_DEFINITIONS})
endif(USE_CAMERA_SUPPORT)

# Find all the libs that don't require extra parameters
foreach(lib ${OUR_LIBS} LensFun GIO GThread GModule Cairo PangoCairo PThread Rsvg2 GDK-PixBuf LibXml2 INotify Sqlite3 Exiv2  CURL PNG JPEG TIFF OpenEXR LCMS2)
  find_package(${lib} REQUIRED)
  include_directories(${${lib}_INCLUDE_DIRS})
  list(APPEND LIBS ${${lib}_LIBRARIES})
  add_definitions(${${lib}_DEFINITIONS})
endforeach(lib)

if(USE_NLS)
  find_package(Gettext)
  if(Gettext_FOUND)
    include_directories(${Gettext_INCLUDE_DIRS})
    list(APPEND LIBS ${Gettext_LIBRARIES})
    add_definitions("-DUSE_GETTEXT")
    message(STATUS "Internationalization: Enabled")
  else()
    message(STATUS "Internationalization: Disabled (libintl not found)")
  endif()
endif(USE_NLS)

if(USE_FLICKR)
  find_package(FLICKCURL)
  if(FLICKCURL_FOUND)
    include_directories(${FLICKCURL_INCLUDE_DIRS})
    list(APPEND LIBS ${FLICKCURL_LIBRARIES})
    add_definitions(${FLICKCURL_DEFINITIONS})
  endif(FLICKCURL_FOUND)
endif(USE_FLICKR)

#
# Detect compile of optional pwstorage backends
#
if(USE_KWALLET) 
find_package(DBUSGLIB)
  if(DBUSGLIB_FOUND)
    list(APPEND SOURCES "common/pwstorage/backend_kwallet.c")
    include_directories(${DBUSGLIB_INCLUDE_DIRS})
    list(APPEND LIBS ${DBUSGLIB_LIBRARIES})
    add_definitions("-DHAVE_KWALLET")
  endif(DBUSGLIB_FOUND)
endif(USE_KWALLET)

if(USE_GNOME_KEYRING)
  find_package(GnomeKeyring)
  if(GNOMEKEYRING_FOUND)
    set(SOURCES ${SOURCES} "common/pwstorage/backend_gkeyring.c")
    include_directories(${GnomeKeyring_INCLUDE_DIRS})
    list(APPEND LIBS ${GnomeKeyring_LIBRARIES})
    add_definitions("-DHAVE_GKEYRING")
  endif(GNOMEKEYRING_FOUND)
endif(USE_GNOME_KEYRING)

# have a small test program, to be run as root on some systems to enable the driver to run cl stuff
add_subdirectory(cltest)

# build opengl slideshow viewer?
if(BUILD_SLIDESHOW) 
  find_package(SDL)
  find_package(OpenGL)
  if(SDL_FOUND AND OPENGL_FOUND)
    add_subdirectory(dtview)
  endif(SDL_FOUND AND OPENGL_FOUND)
endif(BUILD_SLIDESHOW)

# needed for the file manager
if(APRIL_FOOLS)
  find_package(VTE)
  if(VTE_FOUND)
    include_directories(${VTE_INCLUDE_DIRS})
    list(APPEND LIBS ${VTE_LIBRARIES})
  endif(VTE_FOUND)
endif(APRIL_FOOLS)

#
# Add HAVE_xxx defines used by darktable
#
if(INOTIFY_FOUND)
  add_definitions("-DHAVE_INOTIFY")
endif(INOTIFY_FOUND)

if(LENSFUN_FOUND)
  add_definitions("-DHAVE_LENSFUN")
endif(LENSFUN_FOUND)

if(GCONF2_FOUND)
  add_definitions("-DHAVE_GCONF")
endif(GCONF2_FOUND)

if(OPENEXR_FOUND)
  add_definitions("-DHAVE_OPENEXR")
endif(OPENEXR_FOUND)

if(USE_OPENCL)
  add_definitions("-DHAVE_OPENCL")
endif(USE_OPENCL)


if(GPHOTO2_FOUND)
  set(SOURCES ${SOURCES} "common/camera_control.c" "control/jobs/camera_jobs.c" "gui/camera_import_dialog.c" "gui/devices.c" )
  add_definitions("-DHAVE_GPHOTO2")
endif(GPHOTO2_FOUND)


#
# Set default compile flags for GCC
#
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -fno-strict-aliasing")
# c++ code doesn't like -Werror (libraw)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fno-strict-aliasing")

if(NOT APPLE)
  # apple build fails on deprecated warnings..
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
endif(NOT APPLE)

if(NOT WIN32)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread")
endif(NOT WIN32)

if(NOT BINARY_PACKAGE_BUILD)
	MESSAGE("-- Checking for -march=native support")
	CHECK_C_COMPILER_FLAG("-march=native" MARCHNATIVE)
	if (MARCHNATIVE)
		set(MARCH "-march=native")	
	else()
		MESSAGE("-- Checking for -mtune=native support")
		CHECK_C_COMPILER_FLAG("-mtune=native" MTUNENATIVE)
		if (MTUNENATIVE)
			set(MARCH "-mtune=native")
		else()
			set(MARCH "-mtune=generic")
		endif()
	endif()
else()
 	set(MARCH "-mtune=generic")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2 -mfpmath=sse ${MARCH} -g")
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations")
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g -D_DEBUG")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse ${MARCH} -g")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g -D_DEBUG")
  

#
# Generate config.h
#
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.h" "${CMAKE_CURRENT_BINARY_DIR}/config.h" @ONLY)
include_directories("${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")


#
# Setup generation of preference dialog files..
#
add_custom_command(
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/../create_preferences.sh ${CMAKE_CURRENT_SOURCE_DIR}/../tools/create_preferences.sh.in
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h
  COMMAND ${CMAKE_CURRENT_BINARY_DIR}/../create_preferences.sh ${CMAKE_CURRENT_SOURCE_DIR}/../data/darktable.schemas > ${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h
)

#
# Generate mapping of key strings to internal metadata id
#
add_custom_command(
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../tools/create_metadata.sh ${CMAKE_CURRENT_SOURCE_DIR}/../tools/metadata.txt
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.c
  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../tools/create_metadata.sh ${CMAKE_CURRENT_SOURCE_DIR}/../tools/metadata.txt ${CMAKE_CURRENT_BINARY_DIR}
)

# this is a dummy library whose sole purpose is to serve as a dependency for subdirs, such as imageio/storage/gallery.
# cmake can't depend on custom targets in other directories than the current one.
add_library(metadata_dummy ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.c ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.h)

#
# build libdarktable
#
add_library(lib_darktable STATIC SHARED ${CMAKE_CURRENT_BINARY_DIR}/preferences_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.h ${CMAKE_CURRENT_BINARY_DIR}/metadata_gen.c ${SOURCES})
if(APPLE)
  set_target_properties(lib_darktable PROPERTIES INSTALL_NAME_DIR "@executable_path/../lib/darktable")
endif(APPLE)
set_target_properties(lib_darktable PROPERTIES OUTPUT_NAME darktable)
set_target_properties(lib_darktable PROPERTIES LINKER_LANGUAGE C)


#
# the libraw part is a bit of a hack:
# the static linking didn't work since it was pulling -lstdc++ and -lm into linker flags.
# so we do a custom dependency and pretend an imported liblibraw_r.a so no other -l are
# appended.
#
add_dependencies(lib_darktable libraw_r)
add_library(libraw_static STATIC IMPORTED)
set_target_properties(libraw_static PROPERTIES IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/external/LibRaw/liblibraw_r.a)
if(APPLE)
  set(LIBRAW_STATIC_LIBS libraw_static stdc++)
else(APPLE)
  set(LIBRAW_STATIC_LIBS libraw_static)
endif(APPLE)

target_link_libraries(lib_darktable ${LIBS} ${LIBRAW_STATIC_LIBS})

# same for librawspeed (can switch it off with -DDONT_USE_RAWSPEED, for macs):
if(NOT DONT_USE_RAWSPEED)
  add_definitions("-DHAVE_RAWSPEED")
  add_dependencies(lib_darktable rawspeed)
  add_library(rawspeed_static STATIC IMPORTED)
  set_target_properties(rawspeed_static PROPERTIES IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/external/rawspeed/librawspeed.a)
  target_link_libraries(lib_darktable ${LIBS} rawspeed_static)
  # compile rawspeed
  add_subdirectory(external/rawspeed)
endif(NOT DONT_USE_RAWSPEED)

install(TARGETS lib_darktable DESTINATION ${LIB_INSTALL}/darktable)
list(APPEND LIBS lib_darktable)

# Compile libraw modules
add_subdirectory(external/LibRaw)

# Compile views modules
add_subdirectory(views)

# Compile lighttable modules
add_subdirectory(libs)

# Compile darkroom modules
add_subdirectory(iop)

# Compile export modules
add_subdirectory(imageio)




#
# build darktable executable
#
add_executable(darktable ${SUBSYSTEM_MACOSX} ${SUBSYSTEM_WIN32} main.c ${RESOURCE_OBJECT})
set_target_properties(darktable PROPERTIES CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
set_target_properties(darktable PROPERTIES CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
set_target_properties(darktable PROPERTIES INSTALL_RPATH $ORIGIN/../${LIB_INSTALL}/darktable)
set_target_properties(darktable PROPERTIES LINKER_LANGUAGE C)
if(APPLE AND USE_OPENCL)
set_target_properties(darktable PROPERTIES LINK_FLAGS -Wl,-syslibroot,/Developer-old/SDKs/MacOSX10.6.sdk)
endif(APPLE AND USE_OPENCL)
target_link_libraries(darktable ${LIBS})
install(TARGETS darktable DESTINATION bin)

=== src/iop/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

include_directories("${CMAKE_CURRENT_BINARY_DIR}/../" "${CMAKE_CURRENT_SOURCE_DIR}")

set(MODULES tonecurve gamma temperature colorcorrection exposure 
	colorin colorout clipping sharpen monochrome basecurve colorzones
	basecurve highlights velvia vignette splittoning grain bilateral
	profile_gamma colorcontrast
	channelmixer graduatednd relight zonesystem demosaic atrous tonemap 
	cacorrect overexposed bloom soften clahe equalizer highpass hotpixels lowlight spots rawdenoise borders nlmeans)



# new/unfinshed/unstable plugins:
set(EXPERIMENTAL_MODULES anlfyeni colorcontrast colortransfer lowpass invert)

add_library(soften MODULE "soften.c")
add_library(bloom MODULE "bloom.c")
add_library(highpass MODULE "highpass.c")
add_library(lowpass MODULE "lowpass.c")
add_library(tonemap MODULE "tonemap.cc")
add_library(tonecurve MODULE "tonecurve.c")
add_library(gamma MODULE "gamma.c")
add_library(temperature MODULE "temperature.c")
add_library(colorcorrection MODULE "colorcorrection.c")
add_library(exposure MODULE "exposure.c")
add_library(equalizer MODULE "equalizer.c")
add_library(colorin MODULE "colorin.c")
add_library(colorout MODULE "colorout.c")
add_library(clipping MODULE "clipping.c")
add_library(sharpen MODULE "sharpen.c")
add_library(monochrome MODULE "monochrome.c")
add_library(basecurve MODULE "basecurve.c")
add_library(colorzones MODULE "colorzones.c")
add_library(highlights MODULE "highlights.c")
add_library(velvia MODULE "velvia.c")
add_library(vignette MODULE "vignette.c")
add_library(splittoning MODULE "splittoning.c")
add_library(grain MODULE "grain.c")
add_library(clahe MODULE "clahe.c")
add_library(anlfyeni MODULE "anlfyeni.c")
add_library(bilateral MODULE "bilateral.cc")
add_library(profile_gamma MODULE "profile_gamma.c")
add_library(colortransfer MODULE "colortransfer.c")
add_library(channelmixer MODULE "channelmixer.c")
add_library(graduatednd MODULE "graduatednd.c")
add_library(relight MODULE "relight.c")
add_library(zonesystem MODULE "zonesystem.c")
add_library(demosaic MODULE "demosaic.c")
add_library(atrous MODULE "atrous.c")
add_library(cacorrect MODULE "cacorrect.c")
add_library(overexposed MODULE "overexposed.c")
add_library(hotpixels MODULE "hotpixels.c")
add_library(lowlight MODULE "lowlight.c")
add_library(spots MODULE "spots.c")
add_library(rawdenoise MODULE "rawdenoise.c")
add_library(borders MODULE "borders.c")
add_library(nlmeans MODULE "nlmeans.c")
add_library(colorcontrast MODULE "colorcontrast.c")
add_library(invert MODULE "invert.c")

if(RSVG2_FOUND)
	add_library(watermark MODULE "watermark.c")
	set(MODULES ${MODULES} watermark)
endif(RSVG2_FOUND)

if(LENSFUN_FOUND)
	add_library(lens MODULE "lens.c")
	set(MODULES ${MODULES} lens)
endif(LENSFUN_FOUND)

# Add libs references
foreach(module ${MODULES})
        target_link_libraries(${module} ${LIBS})
endforeach(module)
foreach(module ${EXPERIMENTAL_MODULES})
        target_link_libraries(${module} ${LIBS})
endforeach(module)

foreach(module ${MODULES})
	install(TARGETS  ${module} DESTINATION ${LIB_INSTALL}/darktable/plugins)
endforeach(module)

if(INSTALL_IOP_EXPERIMENTAL)
  message("-- Installing experimental iop plugins")
  foreach(module ${EXPERIMENTAL_MODULES})
    	install(TARGETS  ${module} DESTINATION ${LIB_INSTALL}/darktable/plugins)
  endforeach(module)
endif(INSTALL_IOP_EXPERIMENTAL)

=== src/libs/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

include_directories("${CMAKE_CURRENT_BINARY_DIR}/../" "${CMAKE_CURRENT_SOURCE_DIR}")
set(MODULES export copy_history styles tagging image select collect recentcollect metadata)

add_library(export MODULE "export.c")
add_library(copy_history MODULE "copy_history.c")
add_library(styles MODULE "styles.c")
add_library(image MODULE "image.c")
add_library(tagging MODULE "tagging.c")
add_library(select MODULE "select.c")
add_library(collect MODULE "collect.c")
add_library(recentcollect MODULE "recentcollect.c")
add_library(metadata MODULE "metadata.c")

if(APRIL_FOOLS)
	if(VTE_FOUND)
		add_library(file_manager MODULE "file_manager.c")
		set(MODULES ${MODULES} file_manager)
		if(VTE_VERSION LESS "0.26.0")
			add_definitions(-DVTE_DEPRECATED=1)
			message("--- vte < 0.26 - using deprecated function")
		else(VTE_VERSION LESS "0.26.0")
			message("--- vte >= 0.26 - using recent function")
		endif(VTE_VERSION LESS "0.26.0")
	endif(VTE_FOUND)
endif(APRIL_FOOLS)

# check if gphoto2 found and add build of camera modules...
if(GPHOTO2_FOUND)
	add_library(capture MODULE "capture.c")
	add_library(camera MODULE "camera.c")
	set(MODULES ${MODULES} capture camera)
endif(GPHOTO2_FOUND)

# Add libs references
foreach(module ${MODULES})
	target_link_libraries(${module} ${LIBS})
endforeach(module)

# Add installation target for each module
foreach(module ${MODULES})
	install(TARGETS  ${module} DESTINATION ${LIB_INSTALL}/darktable/plugins/lighttable)
endforeach(module)

=== debian/changelog ===
darktable (0.9.3-2ubuntu1) precise; urgency=low

  * Sync on Debian
  * Drop deprecated g_thread_init(), fixes FTBFS
    - add debian/patches/drop_g_thread_init.patch
    - add debian/patches/series
  * Mark Debian Vcs-* as XS-Debian-Vcs-*
    - update debian/control

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 05 Feb 2012 18:25:53 -0600

darktable (0.9.3-2) unstable; urgency=low

  * Bug fix: "Darktable is missing Flickr export option", thanks to Mike
    Alborn (Closes: #644517).

 -- David Bremner <bremner@debian.org>  Tue, 24 Jan 2012 17:27:06 -0400

darktable (0.9.3-1) unstable; urgency=low

  * New upstream version

 -- David Bremner <bremner@debian.org>  Sun, 13 Nov 2011 10:46:00 -0400

=== debian/control ===
Source: darktable
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Bernd Zeimetz <bzed@debian.org>, David Bremner <bremner@debian.org>
Build-Depends: debhelper (>= 7.0.50~), cmake, 
 liblcms2-dev, libgtk2.0-dev, libglib2.0-dev, libcairo2-dev, 
 libjpeg-dev, libpng-dev, libgconf2-dev, liblensfun-dev,
 libtiff-dev, libexiv2-dev, intltool, libglade2-dev,
 libsqlite3-dev, libopenexr-dev, libgphoto2-2-dev,
 libcurl4-gnutls-dev|libcurl-dev, libdbus-glib-1-dev, libgnome-keyring-dev,
 librsvg2-dev, libflickcurl-dev
Standards-Version: 3.9.2
Homepage: http://darktable.sourceforge.net/
XS-Debian-Vcs-Git: git://git.debian.org/pkg-phototools/darktable.git
XS-Debian-Vcs-Browser: http://git.debian.org/?p=pkg-phototools/darktable.git;a=summary

Package: darktable
Architecture: any-i386 any-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, gtk2-engines
Replaces: darktable-plugins-legacy (<< 0.9), darktable-plugins-experimental (<< 0.9)
Breaks: darktable-plugins-legacy (<< 0.9), darktable-plugins-experimental (<< 0.9)
Description: virtual lighttable and darkroom for photographers
 Darktable manages your digital negatives in a database and lets you view
 them  through a zoomable lighttable. it also enables you to develop raw
 images and enhance them.
 .
 It tries to fill the gap between the many excellent existing free
 raw converters and image management tools (such as ufraw or f-spot).
 The user interface is built around efficient caching of image metadata and
 mipmaps, all stored in a database. the user will always be able to interact,
 even if the full resolution image is not yet loaded.
 .
 All editing is fully non-destructive and only operates on cached image
 buffers for display. the full image is only converted during export. The
 frontend is written in gtk+/cairo, the database uses sqlite3, raw image
 loading is done using libraw, high-dynamic range, and standard image formats
 such as jpeg are also supported. The core operates completely on floating
 point values, so darktable can not only be used for photography but also for
 scientifically acquired images or output of renderers (high dynamic range).

Package: darktable-dbg
Architecture: any-i386 any-amd64
Section: debug
Priority: extra
Depends: ${misc:Depends}, darktable (= ${binary:Version})
Description: virtual lighttable and darkroom for photographers
 Darktable manages your digital negatives in a database and lets you view
 them  through a zoomable lighttable. it also enables you to develop raw
 images and enhance them.
 .
 This package contains the debugging symbols

Package: darktable-plugins-experimental
Architecture: any-i386 any-amd64
Replaces: darktable (<<0.9)
Breaks: darktable (<<0.9)
Depends: ${shlibs:Depends}, ${misc:Depends}, darktable (= ${binary:Version})
Description: virtual lighttable and darkroom for photographers (experimental plugins)
 Darktable manages your digital negatives in a database and lets you view
 them  through a zoomable lighttable. it also enables you to develop raw
 images and enhance them.
 .
 This package contains the experimental plugins which may be unstable and/or
 may cause weird behavior.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

SOURCEPKG=$(shell dpkg-parsechangelog | sed  -n 's/^Source: \(.*\)/\1/p')
UPSTREAM=$(shell dpkg-parsechangelog |  sed -n 's/^Version: \(.*\)-[^-]*/\1/p')
SHA1=$(lastword $(subst ~g, ,$(UPSTREAM)))
ORIG=${SOURCEPKG}_${UPSTREAM}.orig.tar.gz

# exclude any plugins from the main package that are in one of the "special" plugin packages
PLUGIN_EXCLUDES=$(patsubst %,-X%,$(notdir $(shell cat $(wildcard debian/darktable-plugins-*.install))))

export CONFIG_SHELL=/bin/bash

%:
	dh $@ --parallel

override_dh_auto_configure: cmake/version.cmake
	dh_auto_configure -- -DDONT_INSTALL_GCONF_SCHEMAS=1 -DINSTALL_IOP_LEGACY=1 -DINSTALL_IOP_EXPERIMENTAL=1 -DBINARY_PACKAGE_BUILD=1

override_dh_auto_build:
	dh_auto_build

override_dh_strip:
	dh_strip --dbg-package=darktable-dbg

override_dh_install:
	dh_install -pdarktable $(PLUGIN_EXCLUDES)
	dh_install --remaining-packages

describe-current-version:
	git describe --tags upstream | sed 's,^release-,,;s,-,+,;s,-,~,;'

get-orig-source:
	git archive --format=tar $(SHA1) | gzip -9 > ../$(ORIG)

.PHONY: describe-current-version git-orig-source

cmake/version.cmake:
	echo "set(PROJECT_VERSION \"${UPSTREAM}\")" > $@

PATCH_EXPORT_SCRIPT=/usr/share/gitpkg/hooks/quilt-patches-deb-export-hook
.PHONY: export-patches

export-patches: 
	[ ! -r debian/patches ] || \
	grep "^\#.*$(notdir $(PATCH_EXPORT_SCRIPT))" debian/patches/series
	rm -rf debian/patches
	bash $(PATCH_EXPORT_SCRIPT)

## darktable 1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,18 +2,17 @@
 cmake_minimum_required(VERSION 2.6)
 cmake_policy(VERSION 2.6)
 
-option(USE_GCONF_BACKEND "Detect and use gconf backend if available." ON)
 option(USE_CAMERA_SUPPORT "Detect and use camera support if available." ON)
 option(USE_NLS "Build Native Language Support (using gettext)" ON)
 option(USE_FLICKR "Enable Flickr support" ON)
 option(USE_KWALLET "Build kwallet password storage backend" ON)
 option(USE_GNOME_KEYRING "Build gnome-keyring password storage backend" ON)
+option(USE_UNITY "Use libunity to report progress in the launcher" OFF)
 option(BUILD_SLIDESHOW "Build the opengl slideshow viewer" ON)
 option(USE_OPENMP "Use openmp threading support." ON)
 option(USE_OPENCL "Use OpenCL support." ON)
 option(USE_DARKTABLE_PROFILING OFF)
 option(DONT_USE_RAWSPEED "Dont compile rawspeed backend." OFF)
-option(DONT_INSTALL_GCONF_SCHEMAS "Dont install gconf schemas, usefull for package creation." OFF)
 option(BUILD_USERMANUAL "Build all the versions of the usermanual." OFF)
 option(INSTALL_IOP_EXPERIMENTAL "Also install unstable, unfinished, broken, and likely-to-change-soon plugins." OFF)
 option(INSTALL_IOP_LEGACY "Also install old plugins we want to get rid of." OFF)
@@ -33,15 +32,18 @@
 #
 if(APPLE)
 	message("-- Mac OSX build detected, setting default features")
-	set(USE_GCONF_BACKEND OFF) 
 	set(USE_OPENCL OFF)
-	set(USE_CAMERA_SUPPORT OFF)
+	set(USE_OPENMP OFF)
+	set(USE_CAMERA_SUPPORT ON)
 	set(BUILD_SLIDESHOW OFF)
 
 	# setup mac ports path...
 	set(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /opt/local/lib)
 	set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} /opt/local/include)
-	
+
+	set(CMAKE_C_FLAGS ${CMAKE_C_FLAGS} -D_DARWIN_C_SOURCE)
+	set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS} -D_DARWIN_C_SOURCE)
+
 	set(LIBS ${LIBS} -Wl,-framework -Wl,Carbon)
 
 	if(USE_OPENCL)
@@ -51,7 +53,6 @@
 
 if(WIN32)
  message("-- Win32 build detected, setting default features")
-  set(USE_GCONF_BACKEND OFF) 
   set(USE_CAMERA_SUPPORT OFF)
 endif(WIN32)
 
@@ -178,16 +179,16 @@
 # 	set(CMAKE_C_FLAGS ${CMAKE_C_FLAGS} "-m${USE_SSE_SET}")
 # endif(USE_SSE_SET)
 
-# Path to install gconf schemas into.
-if(NOT DT_GCONF_SCHEMA_DIR)
-  # a home install would use: "xml:readwrite:${HOME}/.gconf"
-  # default gconftool-2 path (gconftool-2 --get-default-source), mostly "xml:merged:/etc/gconf/gconf.xml.defaults"
-  execute_process (COMMAND gconftool-2 --get-default-source OUTPUT_VARIABLE DT_GCONF_SCHEMA_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
-endif(NOT DT_GCONF_SCHEMA_DIR)
-
 # setup some theme specific variables
 set(THEME hicolor)
 set(THEME_DIRECTORY ${CMAKE_INSTALL_PREFIX}/share/icons/${THEME})
+
+# we need some specific functions:
+IF(CMAKE_SYSTEM MATCHES "SunOS.*")
+add_definitions("-D_XOPEN_SOURCE=600")
+else(CMAKE_SYSTEM MATCHES "SunOS.*")
+add_definitions("-D_XOPEN_SOURCE=700")
+endif(CMAKE_SYSTEM MATCHES "SunOS.*")
 
 # lets continue into build directories
 add_subdirectory(src)

=== data/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

add_subdirectory(pixmaps)

add_subdirectory(kernels)

#
# Generate and instal gtkrc
#
set(GTKRC_FONT_SIZE 8)
if(APPLE)
  # 8 is very tiny on mac
  set(GTKRC_FONT_SIZE 11)
endif(APPLE)
configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/darktable.gtkrc.in ${CMAKE_CURRENT_BINARY_DIR}/darktable.gtkrc )


#
# Add files that should go into shared
#
set(SHARE_FILES ${CMAKE_CURRENT_BINARY_DIR}/darktable.gtkrc)
install(FILES ${SHARE_FILES} DESTINATION ${SHARE_INSTALL})

#
# web gallery export support files:
#
set(WEB_FILES style/style.css style/favicon.ico)
install(FILES ${WEB_FILES} DESTINATION ${SHARE_INSTALL}/style/)

#
# Install other system shares
#
install(FILES darktable.desktop DESTINATION ./share/applications)

#
# Install watermarks
#
FILE(GLOB WATERMARKS "watermarks/*.svg")
install(FILES ${WATERMARKS} DESTINATION ${SHARE_INSTALL}/watermarks)

#
# Install gdb command file for backtrace generation
#
install(FILES gdb_commands DESTINATION ${SHARE_INSTALL})

#
# Setup some custom commands to generate a darktablerc template
# out of the darktable.schemas file.
 add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys
    COMMAND 
        grep '<key>' ${CMAKE_CURRENT_SOURCE_DIR}/darktable.schemas | 
        sed -e 's/<key>//g' -e 's/<\\/key>//g' -e 's/\\/schemas\\/apps\\/darktable\\///g' | 
        nl -s: | 
        sed -e 's/^[ \\t]*//\;s/[ \\t]*$$//' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys
  )
 
  add_custom_command (
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
    COMMAND 
        grep '<default>' ${CMAKE_CURRENT_SOURCE_DIR}/darktable.schemas | 
        sed -e 's/<default>//g' -e 's/<\\/default>//g' | 
        nl -s: | 
        sed -e 's/^[ \\t]*//\;s/[ \\t]*$$//' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
        
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys
  )
 
  if(NOT APPLE)
    add_custom_command (
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc
        COMMAND 
          join -1 1 -2 1 -o 1.2 2.2 ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values | 
          sed -e 's/ /=/g' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_in
          || (echo "*** error: please check if you have coreutils installed! we need grep, sed, nl, and join ***" &1>&2 | false)
          && grep plugins ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_in > /dev/null && mv ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_in ${CMAKE_CURRENT_BINARY_DIR}/darktablerc
          # only move over if something is in there at all.
        
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
    )
  else()
    add_custom_command (
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/darktablerc
        COMMAND 
          join -1 1 -2 1 -o '1.2 2.2' ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_keys ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values | 
          sed -e 's/ /=/g' > ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_in
          || (echo "*** error: please check if you have coreutils installed! we need grep, sed, nl, and join ***" &1>&2 | false)
          && grep plugins ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_in > /dev/null && mv ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_in ${CMAKE_CURRENT_BINARY_DIR}/darktablerc
          # only move over if something is in there at all.
        
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc_values
    )
  endif(NOT APPLE)
 
  add_custom_target(darktablerc ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/darktablerc)
 
  # first of all install darktablerc file into share as template
  # postinst script should copy this into users homedirectory 
  # $HOME/.config/darktable/darktable.rc
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/darktablerc DESTINATION ${SHARE_INSTALL}/)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -6,11 +6,13 @@
 # Add files for libdarktable
 #
 FILE(GLOB SOURCE_FILES
+  "common/cache.c"
   "common/collection.c" 
   "common/colorlabels.c" 
   "common/colormatrices.c" 
   "common/colorspaces.c" 
   "common/darktable.c" 
+  "common/database.c"
   "common/exif.cc" 
   "common/film.c" 
   "common/fswatch.c" 
@@ -27,7 +29,9 @@
   "common/imageio_tiff.c" 
   "common/imageio_rawspeed.cc" 
   "common/metadata.c" 
+  "common/mipmap_cache.c"
   "common/styles.c" 
+  "common/selection.c"
   "common/tags.c" 
   "common/utility.c" 
   "common/variables.c" 
@@ -36,30 +40,33 @@
   "common/opencl.c"
   "common/dynload.c"
   "common/dlopencl.c"
+  "common/ratings.c"
   "control/control.c"  
   "control/jobs/control_jobs.c"  
   "control/jobs/develop_jobs.c"  
-  "control/jobs/film_jobs.c"
+  "control/jobs/film_jobs.c"  
   "control/jobs/image_jobs.c"
+  "control/signal.c"
   "develop/develop.c"
   "develop/imageop.c"
   "develop/pixelpipe.c"
   "develop/blend.c"
   "develop/tiling.c"
-  "dtgtk/*.c"
+  "dtgtk/button.c"
+  "dtgtk/icon.c"
+  "dtgtk/label.c"
+  "dtgtk/slider.c"
+  "dtgtk/gradientslider.c"
+  "dtgtk/tristatebutton.c"
+  "dtgtk/togglebutton.c"
+  "dtgtk/paint.c"
+  "dtgtk/resetlabel.c"
   "gui/accelerators.c"
-  "gui/background_jobs.c"
   "gui/contrast.c"  
   "gui/gtk.c"  
-  "gui/histogram.c"  
-  "gui/iop_history.c"  
-  "gui/iop_modulegroups.c"  
-  "gui/metadata.c"  
-  "gui/navigation.c"  
   "gui/preferences.c"  
   "gui/presets.c"  
   "gui/styles_dialog.c"  
-  "gui/tool_colorlabels.c"  
   "libs/lib.c"
   "views/view.c"
   )
@@ -102,16 +109,6 @@
 include_directories(${LIBXML2_INCLUDE_DIR})
 list(APPEND LIBS ${LIBXML2_LIBRARIES})
 add_definitions(${LIBXML2_DEFINITIONS})
-
-
-# Check for gconf2 / broken cmake module can't be included in the foreach() below
-if(USE_GCONF_BACKEND)
-  find_package(GConf2)
-  include_directories(${GConf2_INCLUDE_DIRS})
-  list(APPEND LIBS ${GConf2_LIBRARIES})
-  add_definitions(${GConf2_DEFINITIONS})
-endif(USE_GCONF_BACKEND)
-
 
 
 if(USE_CAMERA_SUPPORT)
@@ -176,6 +173,15 @@
 # have a small test program, to be run as root on some systems to enable the driver to run cl stuff
 add_subdirectory(cltest)
 
+if(USE_UNITY)
+  find_package(Unity)
+  if(UNITY_FOUND)
+    add_definitions(-DHAVE_UNITY)
+    include_directories(${UNITY_INCLUDE_DIRS})
+    list(APPEND LIBS ${UNITY_LIBRARIES})
+  endif(UNITY_FOUND)
+endif(USE_UNITY)
+
 # build opengl slideshow viewer?
 if(BUILD_SLIDESHOW) 
   find_package(SDL)
@@ -205,10 +211,6 @@
   add_definitions("-DHAVE_LENSFUN")
 endif(LENSFUN_FOUND)
 
-if(GCONF2_FOUND)
-  add_definitions("-DHAVE_GCONF")
-endif(GCONF2_FOUND)
-
 if(OPENEXR_FOUND)
   add_definitions("-DHAVE_OPENEXR")
 endif(OPENEXR_FOUND)
@@ -219,7 +221,7 @@
 
 
 if(GPHOTO2_FOUND)
-  set(SOURCES ${SOURCES} "common/camera_control.c" "control/jobs/camera_jobs.c" "gui/camera_import_dialog.c" "gui/devices.c" )
+  set(SOURCES ${SOURCES} "common/camera_control.c" "control/jobs/camera_jobs.c" "gui/camera_import_dialog.c" )
   add_definitions("-DHAVE_GPHOTO2")
 endif(GPHOTO2_FOUND)
 
@@ -258,11 +260,11 @@
  	set(MARCH "-mtune=generic")
 endif()
 
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2 -mfpmath=sse ${MARCH} -g")
-set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2 -mfpmath=sse -g")
+set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations ${MARCH}")
 set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g -D_DEBUG")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse ${MARCH} -g")
-set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse -g")
+set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -ffast-math -fexpensive-optimizations ${MARCH}")
 set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g -D_DEBUG")

=== debian/changelog ===
darktable (1.0-1) experimental; urgency=low

  * New upstream release
  * Bug fix: "darktable gconf schemas cause warnings on each gconf2
    trigger call", thanks to Julien Valroff (Closes: #624763).
  * Bump standards version (no changes).

 -- David Bremner <bremner@debian.org>  Thu, 15 Mar 2012 19:14:57 -0300
